package com.micle.loginprotection.network;

import com.micle.loginprotection.LoginProtection;
import com.micle.loginprotection.setup.Config;
import net.minecraft.entity.player.ServerPlayerEntity;
import net.minecraft.network.PacketBuffer;
import net.minecraft.potion.EffectInstance;
import net.minecraft.potion.Effects;
import net.minecraft.util.text.StringTextComponent;
import net.minecraftforge.fml.network.NetworkEvent;

import java.util.function.Supplier;

public class C2SKeyPress {
    public C2SKeyPress() { }

    public static void encode(final C2SKeyPress msg, final PacketBuffer packet_buffer) { }

    public static C2SKeyPress decode(final PacketBuffer packet_buffer) {
        return new C2SKeyPress();
    }

    public static void handle(final C2SKeyPress msg, final Supplier<NetworkEvent.Context> context_supplier) {
        final NetworkEvent.Context context = context_supplier.get();
        context.enqueueWork(() -> {
            final ServerPlayerEntity sender = context.getSender();
            if (sender == null) { return; }
            if (LoginProtection.protected_players.getPlayer(sender.getUUID()) == null) { return; }
            if (!LoginProtection.protected_players.getPlayer(sender.getUUID()).isLoading()) { return; }

            if (!Config.Server.POST_GRACE_ENABLED.get()) {
                LoginProtection.protected_players.removePlayer(sender.getUUID());
                sender.sendMessage(new StringTextComponent("[LoginProtection] You are now seen as active."), sender.getUUID());
            } else {
                LoginProtection.protected_players.getPlayer(sender.getUUID()).setLoading(false);
                sender.sendMessage(new StringTextComponent("[LoginProtection] Grace period started!"), sender.getUUID());
            }
            if (sender.isInWater()) {
                if (Config.Server.POST_DROWN_ENABLED.get()) {
                    sender.setAirSupply(sender.getMaxAirSupply());
                }
                if (Config.Server.POST_WATER_ENABLED.get()) {
                    sender.addEffect(new EffectInstance(Effects.WATER_BREATHING, Config.Server.POST_WATER_DURATION.get()*20, 0));
                }
            }
            if (sender.isInLava() && Config.Server.POST_LAVA_ENABLED.get()) {
                sender.addEffect(new EffectInstance(Effects.FIRE_RESISTANCE, Config.Server.POST_LAVA_DURATION.get()*20, 0));
            }
            if (sender.isOnFire() && Config.Server.POST_FIRE_ENABLED.get()) {
                sender.addEffect(new EffectInstance(Effects.FIRE_RESISTANCE, Config.Server.POST_FIRE_DURATION.get()*20, 0));
            }
        });
        context.setPacketHandled(true);
    }
}
